try/finally with bash shellGetting “ensure” / “finally” functionality in a shell command (not script)?How do I set permissions recursively on a dir (with ACL enabled)?How can avoid these spurious characters in my bash prompt?Editing lines in a file using a bash script?Parse XML file to copy the content into another file at a particular spot in the file?How to make bash built-in “read” ignore commented or empty lines?Getting “ensure” / “finally” functionality in a shell command (not script)?How to create a loop with five (5) input variables?sed - if condition met, use next pattern
What are the uses and limitations of Persuasion, Insight, and Deception against other PCs?
Why isn’t SHA-3 in wider use?
What is my malfunctioning AI harvesting from humans?
Three legged NOT gate? What is this symbol?
Why is transplanting a specific intact brain impossible if it is generally possible?
Can the ground attached to neutral fool a receptacle tester?
If "more guns less crime", how do gun advocates explain that the EU has less crime than the US?
elisp regular expression build problem
Double redundancy for the Saturn V LVDC computer memory, how were disagreements resolved?
Are differences between uniformly distributed numbers uniformly distributed?
CTCI Chapter 1 : Palindrome Permutation
Is this curved text blend possible in Illustrator?
constant evaluation when using differential equations.
Why do funding agencies like the NSF not publish accepted grants?
Is it okay for a ticket seller to grab a tip in the USA?
Bitcoin successfully deducted on sender wallet but did not reach receiver wallet
What happens if I delete an icloud backup?
Is refreshing multiple times a test case for web applications?
Can a fight scene, component-wise, be too complex and complicated?
Continuous vertical line using booktabs in tabularx table?
Blocking people from taking pictures of me with smartphone
How are you supposed to know the strumming pattern for a song from the "chord sheet music"?
What game uses dice with sides powers of 2?
Te-form and かつ and も?
try/finally with bash shell
Getting “ensure” / “finally” functionality in a shell command (not script)?How do I set permissions recursively on a dir (with ACL enabled)?How can avoid these spurious characters in my bash prompt?Editing lines in a file using a bash script?Parse XML file to copy the content into another file at a particular spot in the file?How to make bash built-in “read” ignore commented or empty lines?Getting “ensure” / “finally” functionality in a shell command (not script)?How to create a loop with five (5) input variables?sed - if condition met, use next pattern
.everyoneloves__top-leaderboard:empty,.everyoneloves__mid-leaderboard:empty,.everyoneloves__bot-mid-leaderboard:empty margin-bottom:0;
I have these three lines:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
I need to make sure the last line always executes..I could do this:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
(
set +e
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
)
or maybe like this:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion && rm -f "$bunion_uds_file" || rm -f "$bunion_uds_file"
I assume creating the subshell and using set +e is slightly less performant etc.
bash shell exit-status
add a comment |
I have these three lines:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
I need to make sure the last line always executes..I could do this:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
(
set +e
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
)
or maybe like this:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion && rm -f "$bunion_uds_file" || rm -f "$bunion_uds_file"
I assume creating the subshell and using set +e is slightly less performant etc.
bash shell exit-status
The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed bySIGKILL
. Then the next instance will fail withEADDRINUSE
when trying to bind to it.
– mosvy
8 hours ago
Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?
– muru
4 hours ago
add a comment |
I have these three lines:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
I need to make sure the last line always executes..I could do this:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
(
set +e
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
)
or maybe like this:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion && rm -f "$bunion_uds_file" || rm -f "$bunion_uds_file"
I assume creating the subshell and using set +e is slightly less performant etc.
bash shell exit-status
I have these three lines:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
I need to make sure the last line always executes..I could do this:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
(
set +e
"$cmd" "$@" | bunion
rm -f "$bunion_uds_file"
)
or maybe like this:
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
"$cmd" "$@" | bunion && rm -f "$bunion_uds_file" || rm -f "$bunion_uds_file"
I assume creating the subshell and using set +e is slightly less performant etc.
bash shell exit-status
bash shell exit-status
edited 9 hours ago
Kusalananda♦
159k18 gold badges314 silver badges500 bronze badges
159k18 gold badges314 silver badges500 bronze badges
asked 9 hours ago
Alexander MillsAlexander Mills
2,4872 gold badges22 silver badges67 bronze badges
2,4872 gold badges22 silver badges67 bronze badges
The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed bySIGKILL
. Then the next instance will fail withEADDRINUSE
when trying to bind to it.
– mosvy
8 hours ago
Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?
– muru
4 hours ago
add a comment |
The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed bySIGKILL
. Then the next instance will fail withEADDRINUSE
when trying to bind to it.
– mosvy
8 hours ago
Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?
– muru
4 hours ago
The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by
SIGKILL
. Then the next instance will fail with EADDRINUSE
when trying to bind to it.– mosvy
8 hours ago
The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by
SIGKILL
. Then the next instance will fail with EADDRINUSE
when trying to bind to it.– mosvy
8 hours ago
Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?
– muru
4 hours ago
Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?
– muru
4 hours ago
add a comment |
1 Answer
1
active
oldest
votes
You could set a trap:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT
"$cmd" "$@" | bunion
This would make the rm -f
command run whenever the shell session terminates, except for when terminating by the KILL
signal.
As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1
"$cmd" "$@" | bunion
I like to put the trap code in a function:cleanup() rm -f $thefile;
and thentrap cleanup EXIT
-- I think it's cleaner, and it solves any quoting problems.
– glenn jackman
8 hours ago
@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.
– Kusalananda♦
8 hours ago
Yes, bash (but not dash or zsh) will also call theEXIT
trap when being killed by aSIGINT
orSIGTERM
, but I don't know how wise it is to rely on that.
– mosvy
8 hours ago
add a comment |
Your Answer
StackExchange.ready(function()
var channelOptions =
tags: "".split(" "),
id: "106"
;
initTagRenderer("".split(" "), "".split(" "), channelOptions);
StackExchange.using("externalEditor", function()
// Have to fire editor after snippets, if snippets enabled
if (StackExchange.settings.snippets.snippetsEnabled)
StackExchange.using("snippets", function()
createEditor();
);
else
createEditor();
);
function createEditor()
StackExchange.prepareEditor(
heartbeatType: 'answer',
autoActivateHeartbeat: false,
convertImagesToLinks: false,
noModals: true,
showLowRepImageUploadWarning: true,
reputationToPostImages: null,
bindNavPrevention: true,
postfix: "",
imageUploader:
brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
allowUrls: true
,
onDemand: true,
discardSelector: ".discard-answer"
,immediatelyShowMarkdownHelp:true
);
);
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f535057%2ftry-finally-with-bash-shell%23new-answer', 'question_page');
);
Post as a guest
Required, but never shown
1 Answer
1
active
oldest
votes
1 Answer
1
active
oldest
votes
active
oldest
votes
active
oldest
votes
You could set a trap:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT
"$cmd" "$@" | bunion
This would make the rm -f
command run whenever the shell session terminates, except for when terminating by the KILL
signal.
As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1
"$cmd" "$@" | bunion
I like to put the trap code in a function:cleanup() rm -f $thefile;
and thentrap cleanup EXIT
-- I think it's cleaner, and it solves any quoting problems.
– glenn jackman
8 hours ago
@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.
– Kusalananda♦
8 hours ago
Yes, bash (but not dash or zsh) will also call theEXIT
trap when being killed by aSIGINT
orSIGTERM
, but I don't know how wise it is to rely on that.
– mosvy
8 hours ago
add a comment |
You could set a trap:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT
"$cmd" "$@" | bunion
This would make the rm -f
command run whenever the shell session terminates, except for when terminating by the KILL
signal.
As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1
"$cmd" "$@" | bunion
I like to put the trap code in a function:cleanup() rm -f $thefile;
and thentrap cleanup EXIT
-- I think it's cleaner, and it solves any quoting problems.
– glenn jackman
8 hours ago
@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.
– Kusalananda♦
8 hours ago
Yes, bash (but not dash or zsh) will also call theEXIT
trap when being killed by aSIGINT
orSIGTERM
, but I don't know how wise it is to rely on that.
– mosvy
8 hours ago
add a comment |
You could set a trap:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT
"$cmd" "$@" | bunion
This would make the rm -f
command run whenever the shell session terminates, except for when terminating by the KILL
signal.
As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1
"$cmd" "$@" | bunion
You could set a trap:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
trap 'rm -f "$bunion_uds_file"' EXIT
"$cmd" "$@" | bunion
This would make the rm -f
command run whenever the shell session terminates, except for when terminating by the KILL
signal.
As mosvy points out in comments, if this is a socket that needs to be cleaned up before use, it would be easier to remove it before recreating and using it:
#!/bin/bash
export bunion_uds_file="$bunion_socks/$(uuidgen).sock";
rm -f "$bunion_uds_file" || exit 1
"$cmd" "$@" | bunion
edited 8 hours ago
answered 9 hours ago
Kusalananda♦Kusalananda
159k18 gold badges314 silver badges500 bronze badges
159k18 gold badges314 silver badges500 bronze badges
I like to put the trap code in a function:cleanup() rm -f $thefile;
and thentrap cleanup EXIT
-- I think it's cleaner, and it solves any quoting problems.
– glenn jackman
8 hours ago
@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.
– Kusalananda♦
8 hours ago
Yes, bash (but not dash or zsh) will also call theEXIT
trap when being killed by aSIGINT
orSIGTERM
, but I don't know how wise it is to rely on that.
– mosvy
8 hours ago
add a comment |
I like to put the trap code in a function:cleanup() rm -f $thefile;
and thentrap cleanup EXIT
-- I think it's cleaner, and it solves any quoting problems.
– glenn jackman
8 hours ago
@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.
– Kusalananda♦
8 hours ago
Yes, bash (but not dash or zsh) will also call theEXIT
trap when being killed by aSIGINT
orSIGTERM
, but I don't know how wise it is to rely on that.
– mosvy
8 hours ago
I like to put the trap code in a function:
cleanup() rm -f $thefile;
and then trap cleanup EXIT
-- I think it's cleaner, and it solves any quoting problems.– glenn jackman
8 hours ago
I like to put the trap code in a function:
cleanup() rm -f $thefile;
and then trap cleanup EXIT
-- I think it's cleaner, and it solves any quoting problems.– glenn jackman
8 hours ago
@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.
– Kusalananda♦
8 hours ago
@glennjackman You've just introduced a quoting problem in that comment's code, but I get what you're saying. For just deleting a single file in a three line script, I personally think not using a function is ok.
– Kusalananda♦
8 hours ago
Yes, bash (but not dash or zsh) will also call the
EXIT
trap when being killed by a SIGINT
or SIGTERM
, but I don't know how wise it is to rely on that.– mosvy
8 hours ago
Yes, bash (but not dash or zsh) will also call the
EXIT
trap when being killed by a SIGINT
or SIGTERM
, but I don't know how wise it is to rely on that.– mosvy
8 hours ago
add a comment |
Thanks for contributing an answer to Unix & Linux Stack Exchange!
- Please be sure to answer the question. Provide details and share your research!
But avoid …
- Asking for help, clarification, or responding to other answers.
- Making statements based on opinion; back them up with references or personal experience.
To learn more, see our tips on writing great answers.
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
StackExchange.ready(
function ()
StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f535057%2ftry-finally-with-bash-shell%23new-answer', 'question_page');
);
Post as a guest
Required, but never shown
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
Sign up or log in
StackExchange.ready(function ()
StackExchange.helpers.onClickDraftSave('#login-link');
);
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Sign up using Google
Sign up using Facebook
Sign up using Email and Password
Post as a guest
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
Required, but never shown
The common practice is to remove a unix domain socket before binding to it. No try/finally, traps, etc could guard against your script just crashing or being killed by
SIGKILL
. Then the next instance will fail withEADDRINUSE
when trying to bind to it.– mosvy
8 hours ago
Possible duplicate of Getting "ensure" / "finally" functionality in a shell command (not script)?
– muru
4 hours ago